package ovh.quinta.sncf_lh

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.Fragment
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import kotlinx.coroutines.*
import kotlinx.serialization.json.JsonArray
import kotlinx.serialization.json.JsonElement
import ovh.quinta.sncf_lh.databinding.FragmentFirstBinding

/**
 * A simple [Fragment] subclass as the default destination in the navigation.
 */
class FirstFragment : Fragment() {
    private val arrivalsURL = "https://api.navitia.io/v1/coverage/sncf/stop_areas/stop_area%3ASNCF%3A87413013/arrivals"
    private var _binding: FragmentFirstBinding? = null

    // This property is only valid between onCreateView and
    // onDestroyView.
    private val binding get() = _binding!!

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        _binding = FragmentFirstBinding.inflate(inflater, container, false)
        return binding.root
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        runBlocking {
            val dataset = TrainData(JsonArray(emptyList()), JsonArray(emptyList()))
            val adapter = ArrivalsAdapter(dataset)
            val recyclerView: RecyclerView = view.findViewById(R.id.recyclerView)
            val llm = LinearLayoutManager(recyclerView.context, LinearLayoutManager.VERTICAL, false)
            recyclerView.adapter = adapter
            recyclerView.layoutManager = llm
            val fetcher = DataFetcher("https://api.navitia.io/v1/coverage/sncf/stop_areas/stop_area%3ASNCF%3A87413013/arrivals", dataset)
            super.onViewCreated(view, savedInstanceState)
            launch {
                fetcher.start()
                while(fetcher.isAlive) delay(50)
            }
        }
    }

    private fun updateUI(json: JsonElement) {

    }

    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }
}
